﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;
using System.Security.Cryptography;
using System.Xml;
using System.Configuration;


namespace SQL2005
{
    public partial class Form1 : Form
    {
        SqlConnection con = new SqlConnection(@"Data Source=SURYODESIGN-PC\SQLEXPRESS;Initial Catalog=SQL2005;Integrated Security=True");
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {         
            Class2005.query = "select * from msbarang";
            string a = "barang";
            Class2005.tampilData(ref a);
            dataGridBarang.DataSource = Class2005.ds;
            dataGridBarang.DataMember = a;
            Class2005.ds.WriteXml("E:\\book.xml");


        }

        private void button3_Click(object sender, EventArgs e)
        {
            if (txtNama.Text == "" | txtStok.Text == "" )
            //gunakan OR untuk argumen membandingkan
            {
                MessageBox.Show("data mesti diisi");
                //Environment.Exit(-1);
                goto berhenti;
                //Pindah Baris ke Berhenti dan skip baris selanjutnya
            }

            int num;
            //buat variabel num
            bool isNum = int.TryParse(txtHarga.Text.ToString() , out num);
            //membuat variabel is Num dan kemudian isi dari variabel isNum itu sendiri
            //mengubah type data dan menyimpan hasilna pada variabel num
            if(!isNum)
            //mengecek nilai isNum apakah false 
            //( karena bukan number melainkan alfabet )
            {
                MessageBox.Show("Harga mesti number");
                //bila false maka tampilkan pesan harga mesti number
                goto berhenti;
                //Pindah Baris ke Berhenti dan skip baris selanjutnya
            }
            isNum = int.TryParse(txtStok.Text.ToString(), out num);
            //mengisi dari variabel isNum itu sendiri dengan 
            //mengubah type data dari txtstok dan menyimpan hasilna pada variabel num
            if (!isNum)
            //mengecek nilai isNum apakah false 
            //( karena bukan number melainkan alfabet )
            {
                MessageBox.Show("stok mesti number");
                //bila false maka tampilkan pesan harga mesti number
                goto berhenti;
                //Pindah Baris ke Berhenti dan skip baris selanjutnya
            }

            con.Open();
            //membuka koneksi
            SqlCommand scom = new SqlCommand();
            //membuat SQLCOMMAND dengan alias scom
            scom.Connection = con;
            //include koneksi ke dalam sqlcommand
            scom.CommandText = "tambahBarang";
            scom.CommandType = CommandType.StoredProcedure;
            //menentukan jenis command , defaultnya adalah commandtype.text

            SqlParameter nama = new SqlParameter("@nama", SqlDbType.VarChar);
            SqlParameter stok = new SqlParameter("@stok", SqlDbType.Int);
            SqlParameter harga = new SqlParameter("@harga", SqlDbType.Int);
            //buat sql parameter dengan nama variabel yg sama pada SQL Stored Procedure yang telah kita buat
            nama.Value = txtNama.Text;
            stok.Value = txtStok.Text;
            harga.Value = txtHarga.Text;
            //isi variabel sql parameter tadi dengan nilai yang telah kita input dari textboxt
            scom.Parameters.Add(nama);
            scom.Parameters.Add(stok);
            scom.Parameters.Add(harga);
            //kemudian add parameter yang telah kita buat tadi kedalam command yang ada
            scom.ExecuteNonQuery();
            //jalankan storedProcedure
            con.Close();
            //akhiri koneksi ( tutup koneksi )
            btnShow.PerformClick();
            //jalankan btnshow untuk refresh data
            berhenti:
            Console.WriteLine("STOP");
            
        }

        private void Form1_Load(object sender, EventArgs e)
        {
         

            //kita gunakan untuk berpindah dari tab yg 1 ke tab yg lain 
            //untuk meload nilai dari combo box pada tab2 yang ada.
            //btnShow.PerformClick();
            tabControl1.SelectedIndex = 1;
            button6.PerformClick();
            button8.PerformClick();
            btnShowTr.PerformClick();
            tabControl1.SelectedIndex = 2;
            Class2005.query = "select * from msuser";
            string a = "user";
            Class2005.tampilData(ref a);
            dataGridUser.DataSource = Class2005.ds;
            dataGridUser.DataMember = a;
            tabControl1.SelectedIndex = 0;

            Class2005.Message = "Selamat Datang Di www.suryodesign.wordpress.com";
            MessageBox.Show(Class2005.Message);


        }

        private void button1_Click_1(object sender, EventArgs e)
        {
            if (txtKode.Text == "")
            {
                MessageBox.Show("Isi dengan Kode Barang");
                goto selesai;
                //kode barang yg akan dicari tidak boleh kosong ,
                //kemudian bila kosong tampilkan message box 
                //dan lompat Code ke bagian Selesai 
            }

            SqlCommand scom = new SqlCommand();
            scom.Connection = con;
            scom.CommandType = CommandType.Text;
            scom.CommandText = "select * from msbarang";
            //buat sql command , include koneksi
            //tentukan jenis perintah , dan isi dengan select

            DataSet ds1 = new DataSet();
            SqlDataAdapter sda = new SqlDataAdapter(scom);
            sda.Fill(ds1, "barang");
            DataTable dt1 = ds1.Tables["barang"];
            DataColumn[] col1 = new DataColumn[1];
            col1[0] =dt1.Columns["KdBarang"];
            dt1.PrimaryKey = col1;
            DataRow rw1 = dt1.Rows.Find(txtKode.Text);
            //cari data pada dataset dengan table barang pada dataset
            //kemudian tentukan primary key pada table tersebut
            //dan cari berdasarkan primary key tersebut

            txtNama.Text = (string)rw1["NamaBarang"];
            txtStok.Text = Convert.ToString(rw1["Stok"]);
            txtHarga.Text = Convert.ToString(rw1["harga"]);
            //tampilkan data yang didapat ke dalam textbox
                
        selesai:
            ;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            SqlCommand scom = new SqlCommand();
            scom.Connection = con;
            scom.CommandType = CommandType.Text;
            scom.CommandText = "select * from msbarang where NamaBarang like '%"+ txtCari.Text +"%'";
            //buat sql command , include koneksi
            //tentukan jenis perintah , dan isi dengan select

            DataSet ds1 = new DataSet();
            SqlDataAdapter sda = new SqlDataAdapter(scom);
            sda.Fill(ds1, "barang");
            dataGridBarang.DataSource = ds1;
            dataGridBarang.DataMember = "barang";   
            //buat dataset, kemudian eksekusi perintah dengan SQLDataAdapter
            //kemudian fill data hasil ekseksusi ke dalam dataset dengan member barang
            //kemudian set source dan member dari datagrid
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {

        }

        private void button5_Click(object sender, EventArgs e)
        {

            if (txtDelete.Text == "" )
            {
                MessageBox.Show("isi data dengan kode barang");
                goto berhenti;
            }

            int num;
            bool isNum = int.TryParse(txtDelete.Text.ToString(), out num);
            if (!isNum)
            {
                MessageBox.Show("Data mesti number");
                goto berhenti;
            }
            
            con.Open();
            SqlCommand scom = new SqlCommand();
            scom.Connection = con;
            scom.CommandType = CommandType.Text;
            scom.CommandText = " delete from MsBarang where KdBarang = '"+ txtDelete.Text +"'";
            scom.ExecuteNonQuery();
            con.Close();
            btnShow.PerformClick();
            
        berhenti:
            Console.WriteLine("STOP");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            txtNama.Text = "";
            txtStok.Text = "";
            txtHarga.Text = "";
            //mengosongkan field nama , stok , dan harga
        }

        private void label5_Click(object sender, EventArgs e)
        {

        }

        private void button6_Click(object sender, EventArgs e)
        {
            SqlCommand scom = new SqlCommand();
            scom.Connection = con;
            scom.CommandType = CommandType.Text;
            scom.CommandText = "select NamaBarang from msbarang";
          
            DataSet ds1 = new DataSet();
            SqlDataAdapter sda = new SqlDataAdapter(scom);
            sda.Fill(ds1, "barang");
            //comboBox1.DataSource = ds1.Tables["barang"] ;
            //comboBox1.DisplayMember = "NamaBarang";
            cmbNamaBarang.DataSource = ds1.Tables["barang"] ;
            cmbNamaBarang.DisplayMember = "NamaBarang";
        }

        private void button7_Click(object sender, EventArgs e)
        {
            
            string a = cmbNamaBarang.Text;
            if (txtQty.Text == "")
            //gunakan OR untuk argumen membandingkan
            {
                MessageBox.Show("Qty mesti diisi");
                //Environment.Exit(-1);
                goto berhenti;
                //Pindah Baris ke Berhenti dan skip baris selanjutnya
            }

            int num;
            //buat variabel num
            bool isNum = int.TryParse(txtQty.Text.ToString(), out num);
            //membuat variabel is Num dan kemudian isi dari variabel isNum itu sendiri
            //mengubah type data dan menyimpan hasilna pada variabel num
            if (!isNum)
            //mengecek nilai isNum apakah false 
            //( karena bukan number melainkan alfabet )
            {
                MessageBox.Show("Qty mesti number");
                //bila false maka tampilkan pesan harga mesti number
                goto berhenti;
                //Pindah Baris ke Berhenti dan skip baris selanjutnya
            }

            con.Open();
            //open koneksi
            SqlCommand scom = new SqlCommand();
            //membuat SQLCOMMAND dengan alias scom
            scom.Connection = con;
            //include koneksi ke dalam sqlcommand
            scom.CommandText = "insert into TrPenerimaan(NamaBarang,Qty) values('" + a  +"','" + txtQty.Text + "')";
            scom.CommandType = CommandType.Text;
            //menentukan jenis command , defaultnya adalah commandtype.text
   
            scom.ExecuteNonQuery();
            //jalankan storedProcedure
            con.Close();
            //akhiri koneksi ( tutup koneksi )
            btnShowTr.PerformClick();
            tabControl1.SelectedIndex = 0;
            btnShow.PerformClick();
            tabControl1.SelectedIndex = 1;
        //jalankan btnshow untuk refresh data
        berhenti:
            Console.WriteLine("STOP");
        }

        private void button8_Click(object sender, EventArgs e)
        {
            string b = "penerimaan";
            Class2005.query = "select * from trpenerimaan";
            Class2005.tampilData(ref b);
            dataGridTransaksi.DataSource = Class2005.ds;
            dataGridTransaksi.DataMember = b;
        }

        private void button8_Click_1(object sender, EventArgs e)
        {
            SqlDataReader dr;
            SqlCommand scom = new SqlCommand();
            scom.Connection = con;
            scom.CommandType = CommandType.Text;
            scom.CommandText = "select * from msbarang";
            con.Open();
            DataSet ds1 = new DataSet();
            SqlDataAdapter sda = new SqlDataAdapter(scom);
            sda.Fill(ds1, "barang");
            dr = scom.ExecuteReader();
            while(dr.Read())
            {
                cmbNamaBarang2.Items.Add(dr.GetValue(1));
            }
            cmbNamaBarang2.SelectedIndex = 0;
            con.Close();
            //dr1.DataSource = dr;
            //dr1.DataTextField = "contactname";
            //dr1.DataValueField = "customerid";
            //dr1.DataBind();
            
        }

        private void button9_Click(object sender, EventArgs e)
        {

            string a = Convert.ToString(cmbNamaBarang2.SelectedItem);
            if (txtQty2.Text == "")
            //gunakan OR untuk argumen membandingkan
            {
                MessageBox.Show("Qty mesti diisi");
                //Environment.Exit(-1);
                goto berhenti;
                //Pindah Baris ke Berhenti dan skip baris selanjutnya
            }

            int num;
            //buat variabel num
            bool isNum = int.TryParse(txtQty2.Text.ToString(), out num);
            //membuat variabel is Num dan kemudian isi dari variabel isNum itu sendiri
            //mengubah type data dan menyimpan hasilna pada variabel num
            if (!isNum)
            //mengecek nilai isNum apakah false 
            //( karena bukan number melainkan alfabet )
            {
                MessageBox.Show("Qty mesti number");
                //bila false maka tampilkan pesan harga mesti number
                goto berhenti;
                //Pindah Baris ke Berhenti dan skip baris selanjutnya
            }

            con.Open();
            //open koneksi
            SqlCommand scom = new SqlCommand();
            //membuat SQLCOMMAND dengan alias scom
            scom.Connection = con;
            //include koneksi ke dalam sqlcommand
            scom.CommandText = "insert into TrPenerimaan(NamaBarang,Qty) values('" + a + "','" + txtQty2.Text + "')";
            scom.CommandType = CommandType.Text;
            //menentukan jenis command , defaultnya adalah commandtype.text

            scom.ExecuteNonQuery();
            //jalankan storedProcedure
            con.Close();
            //akhiri koneksi ( tutup koneksi )
            btnShowTr.PerformClick();
            tabControl1.SelectedIndex = 0;
            btnShow.PerformClick();
            tabControl1.SelectedIndex = 1;
        //jalankan btnshow untuk refresh data
        berhenti:
            Console.WriteLine("STOP");
        }

        private void button7_Click_1(object sender, EventArgs e)
        {

         string a = "barang";
         Class2005.tampilData(ref a);
            
         dataGridUser.DataSource = Class2005.ds;
         dataGridUser.DataMember = a;
        }


        private void button7_Click_2(object sender, EventArgs e)
        {
            string rethash = "";
            System.Security.Cryptography.SHA1 hash = System.Security.Cryptography.SHA1.Create();
            System.Text.ASCIIEncoding encoder = new System.Text.ASCIIEncoding();
            byte[] combined = encoder.GetBytes(txtPass2.Text);
            hash.ComputeHash(combined);
            rethash = Convert.ToBase64String(hash.Hash);
            MessageBox.Show(rethash);
        }

        private void button9_Click_2(object sender, EventArgs e)
        {
            ClassInduk2005 ClassAnak2005 = new ClassInduk2005();
            string enkripMd5 = Class2005.stringMD5 = txtPass1.Text;
            string enkripSha1 = Class2005.stringSHA1 = txtPass2.Text;
            string query = "insert into MsUser values('" + txtUsername.Text + "','" + Class2005.stringMD5 + "','" + Class2005.stringSHA1 + "')";
            
            Class2005.insertData(ref query);

            Class2005.query = "select * from msuser";
            string a = "user";
            Class2005.tampilData(ref a);
            dataGridUser.DataSource = Class2005.ds;
            dataGridUser.DataMember = a;
        }

        private void button7_Click_3(object sender, EventArgs e)
        {

        }

        private void button9_Click_1(object sender, EventArgs e)
        {
            // Create an isntance of XmlTextReader and call Read method to read the file

            XmlTextReader textReader = new XmlTextReader("E:\\book.xml");

            textReader.Read();

            // If the node has value

            while (textReader.Read())
            {
                // Move to fist 
                textReader.MoveToElement();
                Console.WriteLine("XmlTextReader Properties Test");
                Console.WriteLine("===================");
                // Read this element's properties and display them on 
                Console.WriteLine("Name:" + textReader.Name);
                Console.WriteLine("Base URI:" + textReader.BaseURI);
                Console.WriteLine("Local Name:" + textReader.LocalName);
                Console.WriteLine("Attribute Count:" + textReader.AttributeCount.ToString());
                Console.WriteLine("Depth:" + textReader.Depth.ToString());
                Console.WriteLine("Line Number:" + textReader.LineNumber.ToString());
                Console.WriteLine("Node Type:" + textReader.NodeType.ToString());
                Console.WriteLine("Attribute Count:" + textReader.Value.ToString());
            }
        }

        private void button10_Click(object sender, EventArgs e)
        {
            int ws = 0;
            int pi = 0;
            int dc = 0;
            int cc = 0;
            int ac = 0;
            int et = 0;
            int el = 0;
            int xd = 0;

            // Read a document
            XmlTextReader textReader = new XmlTextReader("E:\\book.xml");

            // Read until end of file
            while (textReader.Read())
            {

                XmlNodeType nType = textReader.NodeType;
                // If node type us a declaration
                if (nType == XmlNodeType.XmlDeclaration)
                {
                    Console.WriteLine("Declaration:" + textReader.Name.ToString());
                    xd = xd + 1;
                }

                // if node type is a comment

                if (nType == XmlNodeType.Comment)
                {
                    Console.WriteLine("Comment:" + textReader.Name.ToString());
                    cc = cc + 1;
                }

                // if node type us an attribute
                if (nType == XmlNodeType.Attribute)
                {
                    Console.WriteLine("Attribute:" + textReader.Name.ToString());
                    ac = ac + 1;
                }

                // if node type is an element
                if (nType == XmlNodeType.Element)
                {
                    Console.WriteLine("Element:" + textReader.Name.ToString());
                    el = el + 1;
                }
                // if node type is an entity\
                if (nType == XmlNodeType.Entity)
                {
                    Console.WriteLine("Entity:" + textReader.Name.ToString());
                    et = et + 1;
                }

                // if node type is a Process Instruction
                if (nType == XmlNodeType.Entity)
                {
                    Console.WriteLine("Entity:" + textReader.Name.ToString());
                    pi = pi + 1;
                }
                // if node type a document

                if (nType == XmlNodeType.DocumentType)
                {
                    Console.WriteLine("Document:" + textReader.Name.ToString());
                    dc = dc + 1;
                }
                // if node type is white space
                if (nType == XmlNodeType.Whitespace)
                {
                    Console.WriteLine("WhiteSpace:" + textReader.Name.ToString());
                    ws = ws + 1;
                }
            }

            // Write the summary
            Console.WriteLine("Total Comments:" + cc.ToString());
            Console.WriteLine("Total Attributes:" + ac.ToString());
            Console.WriteLine("Total Elements:" + el.ToString());
            Console.WriteLine("Total Entity:" + et.ToString());
            Console.WriteLine("Total Process Instructions:" + pi.ToString());
            Console.WriteLine("Total Declaration:" + xd.ToString());
            Console.WriteLine("Total DocumentType:" + dc.ToString());
            Console.WriteLine("Total WhiteSpaces:" + ws.ToString());
        }

        private void button11_Click(object sender, EventArgs e)
        {
            // Create a new file in C:\\ dir
            XmlTextWriter textWriter = new XmlTextWriter("E:\\book.xml", null);
            // Opens the document
            textWriter.WriteStartDocument();
            // Write comments
            textWriter.WriteComment("First Comment XmlTextWriter Sample Example");
            textWriter.WriteComment("myXmlFile.xml in root dir");
            // Write first element
            textWriter.WriteStartElement("Student");
            textWriter.WriteStartElement("r", "RECORD", "urn:record");
            // Write next element
            textWriter.WriteStartElement("Name", "");
            textWriter.WriteString("Student");
            textWriter.WriteEndElement();
            // Write one more element
            textWriter.WriteStartElement("Address", ""); textWriter.WriteString("Colony");
            textWriter.WriteEndElement();
            // WriteChars
            char[] ch = new char[3];
            ch[0] = 'a';
            ch[1] = 'r';
            ch[2] = 'c';
            textWriter.WriteStartElement("Char");
            textWriter.WriteChars(ch, 0, ch.Length);
            textWriter.WriteEndElement();
            // Ends the document.
            textWriter.WriteEndDocument();
            // close writer
            textWriter.Close();
        }

        private void button12_Click(object sender, EventArgs e)
        {
            //Create the XmlDocument.
        XmlDocument doc = new XmlDocument();
        doc.LoadXml(("<Student type='regular' Section='B'><Name>Tommyex</Name></Student>"));
        //Save the document to a file.
        doc.Save("E:\\book.xml");
        //You can also use Save method to display contents on console if you pass Console.Out as a
        //arameter. For example:
        doc.Save(Console.Out); 
        }

        private void button13_Click(object sender, EventArgs e)
        {
            XmlDocument doc = new XmlDocument();
            //Load the the document with the last book node.
            XmlTextReader reader = new XmlTextReader("E:\\book.xml");
            reader.Read();
            // load reader
            doc.Load(reader);
            // Display contents on the console
            doc.Save(Console.Out); 
        }

        private void button14_Click(object sender, EventArgs e)
        {
            string myXMLfile = "E:\\book.xml";
            DataSet myDataSet = new DataSet();
            myDataSet.ReadXml(myXMLfile);
            dataGridBarang.DataSource = myDataSet;
            dataGridBarang.DataMember = "barang";

        }
    }
}
